import { __makeTemplateObject } from "tslib";
import { borderRadius, colors, gridSize, math, themed } from '@uidu/theme';
import styled from 'styled-components';
var DN50A = colors.DN50A, DN60A = colors.DN60A, N0 = colors.N0, N50A = colors.N50A, N60A = colors.N60A, P300 = colors.P300;
// dialog may not be smaller than 160px or larger than 600px
var dialogWidth = function (_a) {
    var width = _a.width;
    return Math.min(Math.max(width, 160), 600) + "px";
};
var borderColor = themed({
    light: N60A,
    dark: DN60A,
});
var shadowColor = themed({
    light: N50A,
    dark: DN50A,
});
var boxShadow = function (props) {
    var border = "0 0 1px " + borderColor(props);
    var shadow = "0 4px 8px -2px " + shadowColor(props);
    return [border, shadow].join(',');
};
export var FillScreen = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  height: 100%;\n  left: 0;\n  overflow-y: auto;\n  position: absolute;\n  top: ", "px;\n  width: 100%;\n"], ["\n  height: 100%;\n  left: 0;\n  overflow-y: auto;\n  position: absolute;\n  top: ", "px;\n  width: 100%;\n"])), function (p) { return p.scrollDistance; });
export var Dialog = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  background: ", ";\n  border-radius: ", "px;\n  box-shadow: ", ";\n  box-sizing: border-box;\n  color: ", ";\n  display: flex;\n  flex-direction: column;\n  width: ", ";\n"], ["\n  background: ", ";\n  border-radius: ", "px;\n  box-shadow: ", ";\n  box-sizing: border-box;\n  color: ", ";\n  display: flex;\n  flex-direction: column;\n  width: ", ";\n"])), P300, borderRadius, boxShadow, N0, dialogWidth);
export var DialogBody = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  flex: 1 1 auto;\n  padding: ", "px ", "px\n    ", "px;\n\n  p:last-child,\n  ul:last-child,\n  ol:last-child {\n    margin-bottom: 0;\n  }\n"], ["\n  flex: 1 1 auto;\n  padding: ", "px ", "px\n    ", "px;\n\n  p:last-child,\n  ul:last-child,\n  ol:last-child {\n    margin-bottom: 0;\n  }\n"])), math.multiply(gridSize, 2), math.multiply(gridSize, 3), gridSize);
// internal elements
export var Heading = styled.h4(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  color: inherit;\n  font-size: 20px;\n  font-style: inherit;\n  font-weight: 500;\n  letter-spacing: -0.008em;\n  line-height: 1.2;\n  margin-bottom: ", "px;\n"], ["\n  color: inherit;\n  font-size: 20px;\n  font-style: inherit;\n  font-weight: 500;\n  letter-spacing: -0.008em;\n  line-height: 1.2;\n  margin-bottom: ", "px;\n"])), gridSize);
export var Image = styled.img(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  height: auto;\n  max-width: 100%;\n"], ["\n  height: auto;\n  max-width: 100%;\n"])));
// actions
export var Actions = styled.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  display: flex;\n  justify-content: space-between;\n  padding: 0 ", "px ", "px;\n"], ["\n  display: flex;\n  justify-content: space-between;\n  padding: 0 ", "px ", "px;\n"])), math.multiply(gridSize, 3), math.multiply(gridSize, 2));
export var ActionItems = styled.div(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  display: flex;\n  margin: 0 -", "px;\n"], ["\n  display: flex;\n  margin: 0 -", "px;\n"])), math.divide(gridSize, 2));
export var ActionItem = styled.div(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  margin: 0 ", "px;\n"], ["\n  margin: 0 ", "px;\n"])), math.divide(gridSize, 2));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
//# sourceMappingURL=Dialog.js.map